/*
  ----------------------------------------------------------------------
  NOME: Marco 
  CONGNOME: Roveri
  MATRICOLA: Docente
  CODICE CALCOLATORE: HAL 9000
  ----------------------------------------------------------------------
*/

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstring>

using namespace std;

/* --------------------------- INIZIO PUNTO 1  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */
struct Info {
  char name[100];
  char type[50];
  int line;
};

struct InfoList {
  Info info;
  InfoList * next;
};

struct ST {
  InfoList * array[10];
  int size;

  ST () {
    int i;
    for(i = 0; i<10; i++) {
      array[i] = NULL;
    }
    size = 10;
  }
};


/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 1  -------------------------- */

/* Non modificare le funzione sotto */

// Utilizzare la funzione sotto per comparara due stringhe, o array di
// caratteri.
bool Compara_stringhe(const char* s1, const char* s2)
{
  return strcmp(s1, s2) == 0;
}

int ST_Hash(ST * s, char * k) {
  int val = 0;
  char c;

  if (s != NULL) {
    while(( c = *k++) != '\0') {
      val = val*997 + c;
    }
    return (((val < 0) ? (val * -1) : val)% s->size);
  }
  else {
    return -1;
  }
}

/* --------------------------- INIZIO PUNTO 2  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */
void ST_Print(ST * st);

void print_list(InfoList * l, int i) {
  while(l != NULL) {
    Info info = l->info;

    cout << i << ": " << info.name << " : " << info.type << " : " << info.line << endl;
    l = l->next;
 }
}

void ST_Print(ST * st) {
  int i;
  
  if (st != NULL) {
    for( i = 0; i < st->size; i++) {
      print_list(st->array[i], i);
    }
  }
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 2 -------------------------- */


/* --------------------------- INIZIO PUNTO 3  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */
Info * ST_Search(ST * s, char k[100]) {
  if (s == NULL) return NULL;

  int index = ST_Hash(s, k);

  InfoList * l = s->array[index];

  while(l != NULL) {
    if (Compara_stringhe(l->info.name, k)) return &(l->info);
    l = l->next;
  }
  return NULL;
}
/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 3 -------------------------- */



/* --------------------------- INIZIO PUNTO 4  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */
bool ST_Insert(ST * s, Info i);

bool ST_Insert(ST * s, Info i) {

  if (ST_Search(s, i.name) != NULL) return false;

  InfoList * n = new InfoList();

  n->info = i;
  // La posizione che dove avere nell'array
  int k = ST_Hash(s, i.name);

  // Inserisco come primo elemento della lista.
  n->next = s->array[k];
  s->array[k] = n;
  
  return true;
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 4 -------------------------- */

/* --------------------------- INIZIO PUNTO 5  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

bool ST_Delete(ST * s, char name[100]);

void delete_element(InfoList * &l, char * name) {

  // Se la lista e' vuota fine
  if (l != NULL) {
    InfoList * temp = l;

    // Se primo elemento
    if (Compara_stringhe(l->info.name, name)) {
        l = l->next;
        delete temp;
        return;
    }
    else {
      // Se elemento intermedio
      while (temp->next != NULL) {
        if (Compara_stringhe(temp->next->info.name, name)) {
          InfoList * r = temp->next;

          temp->next = temp->next->next;
          delete r;
          return;
        }
        temp = temp->next;
      }
    }
  }
}

bool ST_Delete(ST * s, char name[100]) {
  if (ST_Search(s, name) == NULL) return false;

  int k = ST_Hash(s, name);

  delete_element(s->array[k], name);
  return true;
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 5 -------------------------- */

/* Non modificare le funzione sotto */

void ST_Read(ST * st, const char * fname) {
  ifstream in;

  in.open(fname);

  while(! in.eof()) {
    Info i;
    char name[100];
    char type[50];
    char buf[10];
    int line;

    in.getline(name, 100);
    if(in.fail()) break;

    in.getline(type, 100);
    if(in.fail()) break;

    in.getline(buf, 10);
    if(in.fail()) break;

    line = atoi(buf);

    strcpy(i.name, name);
    strcpy(i.type, type);
    i.line = line;

    ST_Insert(st, i);
  }

  in.close();
}

void dealloca_lista(InfoList * & p) {
  InfoList * l;

  while(p != NULL) {
    l = p;
    p = p->next;
    delete l;
  }
}

void ST_Destroy(ST * s) {
  int i;

  if(s != NULL) {
    for(i = 0; i<s->size; i++) {
      dealloca_lista(s->array[i]);
    }
  }
}

// ----------------------------------------------------------------------
// Main del programma
// ----------------------------------------------------------------------

int main() 
{
  Info * i;

  ST * s = new ST();

  ST_Read(s, "st.dat");

  cout << "========================================" << endl;
  cout << "Initial symbol tabble" << endl;
  ST_Print(s);

  cout << "========================================" << endl;

  i = ST_Search(s, "j");
  if (i != NULL) {
    cout << "Trovato il simbolo " << i->name << endl;
    cout << "Il suo tipo e': " << i->type << endl;
  }
  else {
    cout << "ERRORE: Non trovato il simbolo " << i->name << endl;
    return 1;
  }

  cout << "========================================" << endl;
  cout << "Removing: j" << endl;
  ST_Delete(s, "j");

  i = ST_Search(s, "j");
  if (i != NULL) {
    cout << "ERRORE: trovato il simbolo " << i->name << endl;
    return 1;
  }

  ST_Print(s);

  cout << "========================================" << endl;

  i = ST_Search(s, "stprime");
  if (i != NULL) {
    cout << "Trovato il simbolo " << i->name << endl;
    cout << "Il suo tipo e': " << i->type << endl;
  }
  else {
    cout << "ERRORE: Non trovato il simbolo " << i->name << endl;
    return 1;
  }

  cout << "========================================" << endl;
  cout << "Removing: stprime" << endl;
  ST_Delete(s, "stprime");

  i = ST_Search(s, "stprime");
  if (i != NULL) {
    cout << "ERRORE: trovato il simbolo " << i->name << endl;
    return 1;
  }

  ST_Print(s);

  cout << "========================================" << endl;

  // Deallocazione delle liste memorizzate in ogni elemento dell'array
  // della tabella dei simboli.
  ST_Destroy(s);

  delete s;

  return 0;
}
